add pull support, untested
[distro-setup] / mount-latest-subvol
1 #!/bin/bash
2 # Copyright (C) 2016 Ian Kelling
3 #
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at
7 #
8 # http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16 # usage: mount-latest-subvol
17
18 [[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
19
20 errcatch() {
21 set -E; shopt -s extdebug
22 _err-trap() {
23 err=$?
24 exec >&2
25 set +x
26 echo "${BASH_SOURCE[1]}:${BASH_LINENO[0]}:in \`$BASH_COMMAND' returned $err"
27 bash-trace 2
28 echo "$0: exiting with code $err"
29 exit $err
30 }
31 trap _err-trap ERR
32 set -o pipefail
33 }
34 bash-trace() {
35 local -i argc_index=0 frame i start=${1:-1} max_indent=8 indent
36 local source
37 local extdebug=false
38 if [[ $(shopt -p extdebug) == *-s* ]]; then
39 extdebug=true
40 fi
41
42 for ((frame=0; frame < ${#FUNCNAME[@]}-1; frame++)); do
43 argc=${BASH_ARGC[frame]}
44 argc_index+=$argc
45 ((frame < start)) && continue
46 if (( ${#BASH_SOURCE[@]} > 1 )); then
47 source="${BASH_SOURCE[frame+1]}:${BASH_LINENO[frame]}:"
48 fi
49 indent=$((frame-start+1))
50 indent=$((indent < max_indent ? indent : max_indent))
51 printf "%${indent}s↳%sin \`%s" '' "$source" "${FUNCNAME[frame]}"
52 if $extdebug; then
53 for ((i=argc_index-1; i >= argc_index-argc; i--)); do
54 printf " %s" "${BASH_ARGV[i]}"
55 done
56 fi
57 echo \'
58 done
59 }
60 errcatch
61
62 tu() {
63 while read -r line; do
64 file="$1"
65 grep -xFq "$line" "$file" || tee -a "$file"<<<"$line"
66 done
67 }
68 e() { printf "%s\n" "$*"; "$@"; }
69 mnt() {
70 dir=$1
71 if ! mountpoint $dir &>/dev/null; then
72 mkdir -p $dir
73 e mount $dir
74 fi
75 }
76 fstab() {
77 while read -r start mpoint end; do
78 l="$start $mpoint $end"
79 # kill off any lines that duplicate the mount point.
80 sed --follow-symlinks -ri "\%$l%b;\%^\s*\S+\s+$mpoint\s%d" /etc/fstab
81 tu /etc/fstab <<<"$l"
82 done
83 }
84 kill-dir() {
85 for sig; do
86 echo kill-dir $sig
87 found_pids=false
88 if pids=$(timeout 4 lsof -t $dir); then
89 found_pids=true
90 timeout 4 lsof -w $dir
91 kill -$sig $pids
92 fi
93 # fuser will find open sockets that lsof won't, for example from gpg-agent.
94 # note: -v shows kernel processes, which then doesn't return true when we want
95 if timeout 4 fuser -m $dir &>/dev/null; then
96 found_pids=true
97 fuser -$sig -mvk $dir
98 fi
99 sleep .5
100 if ! $found_pids; then
101 return 0
102 fi
103 done
104 return 1
105 }
106
107 force=false
108 if [[ $1 == -f ]]; then
109 force=true
110 fi
111
112 ret=0
113
114 ##### begin setup fstab for subvols we care about ######
115 first_root_crypt=$(awk '$2 == "/" {print $1}' /etc/mtab)
116 fstab <<EOF
117 $first_root_crypt /a btrfs noatime,subvol=a 0 0
118 EOF
119
120 shopt -s nullglob
121
122 # ssh and probably some other things care about parent directory
123 # ownership, and ssh doesn\'t allow any group writable parent
124 # directories, so we are forced to use a directory structure similar
125 # to home directories
126 f=(/mnt/root/btrbk/q.*)
127 if [[ -e $f ]]; then
128 fstab <<EOF
129 $first_root_crypt /q btrfs noatime,subvol=q,gid=1000 0 0
130 /q/p /p none bind 0 0
131 EOF
132 fi
133
134 f=(/mnt/root/btrbk/o.*)
135 if [[ -e $f ]]; then
136 fstab <<EOF
137 $first_root_crypt /o btrfs noatime,subvol=o 0 0
138 /o/m /m none bind 0 0
139 EOF
140 fi
141
142 if [[ $HOSTNAME == frodo ]]; then
143 fstab <<EOF
144 $first_root_crypt /i btrfs noatime,subvol=i 0 0
145 EOF
146 fi
147 ##### end setup fstab for subvols we care about ######
148
149 for vol in q a o i; do
150 d=/$vol
151 if ! awk '{print $2}' /etc/fstab | grep -xF $d &>/dev/null; then
152 continue
153 fi
154
155
156 ##### begin building up list of bind mounts ######
157 binds=() # list of bind mounts
158 roots=($d) # list of bind mounts, plus the original mount
159 while true; do
160 new_roots=()
161 for r in ${roots[@]}; do
162 # eg. when r=/q/p, for lines like
163 # /q/p /p none bind 0 0
164 # output /p
165 new_roots+=($(sed -rn "s#^$r/\S+\s+(\S+)\s+none\s+bind\s.*#\1#p" /etc/fstab))
166 done
167 (( ${#new_roots} )) || break
168 binds+=(${new_roots[@]})
169 roots=( ${new_roots[@]} )
170 done
171 ##### end building up list of bind mounts ######
172
173
174 # if latest is already mounted, make sure binds are mounted and move on
175 if e check-subvol-stale $d; then
176 mnt $d
177 for b in ${binds[@]}; do
178 mnt $b
179 done
180 continue
181 fi
182
183 fresh_snap=$(</nocow/btrfs-stale/$vol)
184 if [[ ! $fresh_snap ]]; then
185 echo "$0: error. empty fresh_snap var"
186 ret=1
187 continue
188 fi
189
190 umount_ret=true
191 unmounted=()
192 for dir in $(echo $d ${binds[*]}\ |tac -s\ ); do
193 if mountpoint $dir; then
194 if e umount -R $dir; then
195 unmounted+=($dir)
196 else
197 if ! kill-dir TERM TERM TERM INT INT HUP HUP; then
198 if $force; then kill-dir KILL; fi
199 fi
200
201 if e umount -R $dir; then
202 unmounted+=($dir)
203 else
204 echo "$0: failed to umount $dir"
205 umount_ret=false
206 ret=1
207 continue
208 fi
209 fi
210 fi
211 done
212
213 if ! $umount_ret; then
214 for dir in ${unmounted[@]}; do
215 mnt $dir
216 done
217 continue
218 fi
219
220 # todo: decipher /mnt/root, like we do in check-subvol-stale
221 cd /mnt/root
222 if [[ -e $vol ]]; then
223 e mv $vol $vol.leaf.$(date +%Y-%m-%dT%H:%M:%S%z)
224 leaf_vols=($vol.leaf.*)
225 for leaf in ${leaf_vols[@]}; do
226 leaf_secs=$(date -d ${leaf#$vol.leaf.} +%s)
227 if (( $(date +%s) - 60*60*24*60 > leaf_secs )); then # 60 days
228 e btrfs sub del $leaf
229 fi
230 done
231 fi
232 # Note, we make a few assumptions in this script, like
233 # $d was not a different subvol id than $vol, and
234 # things otherwise didn't get mounted very strangely.
235 e btrfs sub snapshot $fresh_snap $vol
236 for dir in $d ${binds[@]}; do
237 e mnt $dir
238 done
239 stale_dir=/nocow/btrfs-stale
240 rm -f $stale_dir/$d
241 done
242
243 ### disabled
244 if [[ $HOSTNAME == kdxxxxxxxxx ]]; then
245 # partitioned it with fai partitioner outside of fai,
246 # because it\'s worth it to have 1% space reserved for boot and
247 # swap partitions in case I ever want to boot off those drives.
248 # as root:
249 # . /a/bin/fai/fai-wrapper
250 # eval-fai-classfile /a/bin/fai/fai/config/class/51-multi-boot
251 # fai-setclass ROTATIONAL
252 # export LUKS_DIR=/q/root/luks/
253 # # because the partition nums existed already
254 # fai-setclass REPARTITION
255 # /a/bin/fai/fai/config/hooks/partition.DEFAULT
256
257 devs=(
258 ata-TOSHIBA_MD04ACA500_84REK6NTFS9A-part1
259 ata-TOSHIBA_MD04ACA500_84R2K773FS9A-part1
260 ata-TOSHIBA_MD04ACA500_8471K430FS9A-part1
261 ata-TOSHIBA_MD04ACA500_8481K493FS9A-part1
262 )
263 first=true
264 for dev in ${devs[@]}; do
265 if $first; then
266 first=false
267 tu /etc/fstab <<EOF
268 /dev/mapper/crypt_dev_$dev /i btrfs noatime,subvol=i,noauto 0 0
269 /dev/mapper/crypt_dev_$dev /mnt/iroot btrfs noatime,subvolid=0,noauto 0 0
270 EOF
271 fi
272 tu /etc/crypttab <<EOF
273 crypt_dev_$dev /dev/disk/by-id/$dev /q/root/luks/host-kd discard,luks
274 EOF
275 if [[ ! -e /dev/mapper/crypt_dev_$dev ]]; then
276 cryptdisks_start crypt_dev_$dev
277 fi
278 done
279 # note, could do an else here and have some kind of mount for /i
280 # on other hosts.
281 fi
282
283 exit $ret